import Returns from '../core/Returns.mjs'
export * from './Types/Complex.mjs'

export const multiply = {
   'Complex<T>,Complex<T>': ({
      T,
      'complex(T,T)': cplx,
      'add(T,T)': plus,
      'subtract(T,T)': sub,
      'self(T,T)': me,
      'conjugate(T)': conj // makes quaternion multiplication work
   }) => Returns(
      `Complex<${T}>`,
      (w,z) => cplx(
         sub(me(w.re, z.re), me(conj(w.im), z.im)),
         plus(me(conj(w.re), z.im), me(w.im, z.re)))
   )
}
